<?php

function PrintArr($arr, $text="Printed Array:")
{
	echo "<p><br><big><b>$text</b></big><p>";
	print_r($arr);
}

function PrintQueryResultGrid($queryresult, $varstoget)
{
	mysql_data_seek($queryresult,0);
	
	$y=0;
	$len=count($varstoget);
	
	echo "<table border><tr>";
	while ($y<$len)
	{	echo "<th>$varstoget[$y]";
		$y++;
	}

	while ( $unpublishedpost_info = mysql_fetch_array($queryresult) )
	{
		$y=0;
		echo "\n<tr>";
		while ($y<$len)
		{
			$varname=$varstoget[$y];
			${$varname} = $unpublishedpost_info[$varname];
			
			echo "<td>${$varname}";
			
			$y++;
		}
	}
	echo "</table>";
}

function MakeUniqueArray($arr)
{
	$res=array_iunique($arr);
	$res=array_merge($res);
	$res=ArrRemoveEmptyValues($res);
	return $res;
}

function MakeSortedUniqueArray($arr)
{	$res=MakeUniqueArray($arr);
	sort($res);
	return $res;
}

function NbspSpaces($string)
{
	$string = str_replace(' ', '&nbsp;', $string);
	return $string;
}
function ArrRemoveEmptyValues($array)
{
	foreach($array as $key => $value)
	{
		if($value == "" || $value == " " || is_null($value)) 
		{
			unset($array[$key]);
		}
	}
	$array = array_values($array);
	return $array;
}

function array_iunique($array)
{
    return array_intersect_key($array,array_unique(array_map(strtolower,$array)));
}

function StripMiddleSpaces($string)
{
   return preg_replace('/\s\s+/', ' ', $string);
}

function TrimComma(&$value)
{	$value=substr ($value, 0, -2);
}

function EncloseOrNull($value, $enclosure)
{	if (!empty($value) && $value!="NULL" && !is_numeric($value) )
	{
		//$reverse_enclosure=strrev($enclosure);
		$value = $enclosure . $value . $enclosure;
	}
	else if (is_numeric($value))
	{	//Then we leave the value as is.
	}
	else $value="NULL";

	return $value;
}


function MakeSafeFilenameString($string)
{	global $maxfilenamelength;

	$string = strtolower($string);

	$string = str_replace('?', ' ', $string);
	$string = str_replace('&', ' and ', $string);
	$string = str_replace(';', ' ', $string);
	$string = str_replace('+', ' plus ', $string);
	$string = str_replace('!', ' ', $string);
	$string = str_replace('.', ' ', $string);
	$string = str_replace(',', ' ', $string);
	$string = str_replace(':', ' ', $string);
	$string = str_replace('$', 'S', $string);
	$string = str_replace('<', ' lt ', $string);
	$string = str_replace('>', ' gt ', $string);

	$string = str_replace("\\", '', $string);
	$string = str_replace("\"", '', $string);
	$string = str_replace("'", '', $string);
	$string = str_replace("/", ' ', $string);

	$string=StripMiddleSpaces($string);
	$string=trim($string);
	$string = ereg_replace(' ', '-', $string);

//I'd rather use underscores instead of dashes but Google disagrees, those fiends:
//http://www.mattcutts.com/blog/dashes-vs-underscores

	$strlen=strlen($string);
	
	if ($strlen>$maxfilenamelength)
	{	$string=substr($string, 0, $maxfilenamelength);
	}

	
	return $string;
}


function TrimEnd($string, $numtotrim)
{	$numtotrim=-$numtotrim;
	$string=substr ($string, 0, $numtotrim);
	return $string;
}

function FormatUnixTimestamp($thists)
{	
	$res = gmdate("Y-m-d H:i:s", $$thists);
	return $res;
}

function GetNowUnixTimestamp()
{	$res = time();
	return $res;
}

function GetTimestamp($rawdate)
{	$res = MakeIntoUnixTime($rawdate);
	$res = gmdate("Y-m-d H:i:s", $res);
	return $res;
}

function MakeIntoUnixTime ($str)
{	
	if (!empty($str))
	{
		if (($timestamp = strtotime($str)) === false) 
		{
			GoBackToFormWithError("invalid timestamp");
		} 
	
	return $timestamp;
	}
}

function FixCheckboxValues()
{	global $checkboxes;

	$x=0;
	$len=count($checkboxes);
	while ($x<$len)
	{	$thisbox=$checkboxes[$x];

		if ($thisbox!="y")
		{	$checkboxes[$x]="n";
		}
		$x++;
	}
}

function FixNumberboxValues()
{	global $numberboxes;
	$x=0;
	$len=count($numberboxes);
	while ($x<$len)
	{	$thisbox=$numberboxes[$x];

		if (!is_numeric($thisbox) || !$thisbox)
		{
			unset($numberboxes[$x]);
		}
		$x++;
	}
}


function MakePostObjectCacheFile($thisfilename, $thiscachedir, $usekey, $thiskey)
{	global $cachevarstoget, $blogcachepath, $dollarsign;

	$filetext = "<?php\n\n";

	foreach ($cachevarstoget as $varname)
	{	$varname=$cachevarstoget[$x];

		global ${$varname};

		if ($usekey)	//Only used by recacheall.php, I think...
		{	$thisvar=${$varname}[$thiskey];
		}
		else
		{	$thisvar=${$varname};
		}
		if ($thisvar)
		{
			$varstring=VarEqualsString("obj" . $varname, $thisvar);

			$filetext .= "$varstring\n\n";
		}
		$x++;
	}

	$objvars=array("post_id", "title", "filename", "cachedir", "category", "type", "topic", "post", "maintagstring", "othertagstring", "month", "year", "usefulness", "fun", "beauty", "necessity", "aesthetic", "utilit", "forfun", "educational", "news", "timesensitive", "outdated", "hidetime", "fav", "trivial", "important", "temphide", "clutterpile", "junkpile", "whenadded", "lastsaved", "displaydate", "lastpublished", "hidetitle", "notforfrontpage", "humorous", "humorousness", "nostandalone", "fullpostinrss", "excludefromrss");

	$objvarstring = "$dollarsign" . "obj";
	$objvarstring .= implode(", $dollarsign" . "obj", $objvars);

	if ($usekey)
	{
		$postid=$post_id[$thiskey];
	}
	else
	{	$postid=$post_id;
	}
	$filetext .= PrintVarName("Blogpost$postid");
	$filetext .= " = new Blogpost(";
	$filetext .= $objvarstring;
	$filetext .= ");\n";

	$filetext .= "\n?>";

	$openthis = $blogcachepath . "/$thiscachedir/$thisfilename.php";	
	$filehandle = fopen($openthis, "w");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);

	return true;
}

function MakePostCacheFile($thisfilename, $thiscachedir)
{	global $cachevarstoget, $blogcachepath;
	
	$x=0;
	$len=count($cachevarstoget);

	$filetext = "<?php\n\n";

	while ($x<$len)
	{	$varname=$cachevarstoget[$x];

		global ${$varname};

		if (isset(${$varname} ) )
		{
			$varstring=VarEqualsString($varname, ${$varname});

			$filetext .= "$varstring\n\n";
		}
		$x++;
	}


	$filetext .= "\n?>";

	$openthis = $blogcachepath . "/$thiscachedir/$thisfilename.php";	
	$filehandle = fopen($openthis, "w");
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);

	return true;
}

function PrintVarname($varname)
{
	global $dollarsign;
	$varstring="$dollarsign" . "$varname";
	return $varstring;
}

function VarEqualsString($varname, $val)
{	global $dollarsign;
	if (is_numeric($val))
	{	$noquotes="true";
	}
	$varstring="$" . "$varname = ";

	$val=addslashes($val);
		$val = str_replace('$', "$" . "dollarsign\" . \"", $val);
//		$val = str_replace('&lt;', "&amp;lt", $val);
//		$val = str_replace('&nbsp;', "&amp;nbsp", $val);

	//$val=addslashes($val);

	if ($noquotes)
	{	$varstring .= "$val";
	}
	else
	{	$varstring .= "\"$val\"";
	}
	$varstring .= ";";
	return $varstring;
}


function MakeIncludeFile($filename, $varname, $val, $usequotes, $writeorappend)
{	global $blogconfigpath;

	if ($filename=="var-lastpub.php")
	{	
		//$usequotes="true";
	}
	else if ($filename=="var-currentcachedir.php")
	{
		//$usequotes="false";
	}
	else
	{	return false;
	}

	$filetext = "<?php\n\n$";
	$filetext .= "$varname =";

	if ($usequotes=="usequotes")
	{	$filetext .= " \"$val\"";
	}
	else
	{	$filetext .= " $val";
	}
	$filetext .= "; \n\n?>";

	$openthis = $blogconfigpath . "/$filename";	
	$filehandle = fopen($openthis, $writeorappend);
	fwrite ($filehandle, $filetext);
	fclose ($filehandle);

	return true;
}


class Blogpost
{
	public $post_id;
	public $title;
	public $filename;
	public $cachedir;

	public $category;
	public $type;
	public $topic;
	public $post;
	public $maintagstring;
	public $othertagstring;
	
	public $month;
	public $year;

	public $usefulness;
	public $fun;
	public $beauty;
	public $necessity;

	public $aesthetic;
	public $utilit;
	public $forfun;
	public $educational;
	public $news;

	public $timesensitive;
	public $outdated;
	public $hidetime;

	public $fav;
	public $trivial;
	public $important;

	public $temphide;
	public $clutterpile;
	public $junkpile;

	public $whenadded;
	public $lastsaved;
	public $displaydate;
	public $lastpublished;
	
	public $hidetitle;
	public $notforfrontpage;
	public $humorous;
	public $humorousness;
	public $nostandalone;
	public $fullpostinrss;
	public $excludefromrss;

    public function __construct($post_id=0, $title=0, $filename=0, $cachedir=0, $category=0, $type=0, $topic=0, $post=0, $maintagstring=0, $othertagstring=0, $month=0, $year=0, $usefulness=0, $fun=0, $beauty=0, $necessity=0, $aesthetic=0, $utilit=0, $forfun=0, $educational=0, $news=0, $timesensitive=0, $outdated=0, $hidetime=0, $fav=0, $trivial=0, $important=0, $temphide=0, $clutterpile=0, $junkpile=0, $whenadded=0, $lastsaved=0, $displaydate=0, $lastpublished=0, $hidetitle=0, $notforfrontpage=0, $humorous=0, $humorousness=0, $nostandalone=0, $fullpostinrss=0, $excludefromrss=0)
    {

$this->post_id=$post_id;
$this->title=$title;

$this->filename=$filename;
$this->cachedir=$cachedir;
$this->category=$category;
$this->type=$type;
$this->topic=$topic;
$this->post=$post;
$this->maintagstring=$maintagstring;
$this->othertagstring=$othertagstring;

$this->month=$month;
$this->year=$year;

$this->usefulness=$usefulness;
$this->fun=$fun;
$this->beauty=$beauty;
$this->necessity=$necessity;
$this->aesthetic=$aesthetic;
$this->utilit=$utilit;
$this->forfun=$forfun;
$this->educational=$educational;
$this->news=$news;
$this->timesensitive=$timesensitive;
$this->outdated=$outdated;
$this->hidetime=$hidetime;
$this->fav=$fav;
$this->trivial=$trivial;
$this->important=$important;
$this->temphide=$temphide;
$this->clutterpile=$clutterpile;
$this->junkpile=$junkpile;
$this->whenadded=$whenadded;
$this->lastsaved=$lastsaved;
$this->displaydate=$displaydate;
$this->lastpublished=$lastpublished;
$this->hidetitle=$hidetitle;
$this->notforfrontpage=$notforfrontpage;
$this->humorous=$humorous;
$this->humorousness=$humorousness;
$this->nostandalone=$nostandalone;
$this->fullpostinrss=$fullpostinrss;
$this->excludefromrss=$excludefromrss;

    }

}


class Category
{
	public $name;
	public $internalsafename;
	public $safename;
	public $titles;
	public $dates;
	public $categories;	//Only with Any_Category will this have more than one kind of entry.
	public $types;
	public $postidsequence;
	public $years;
//	public $months;

	public $postidsbyear;
	public $postidsbymonth;
	
	public $categoriesbyear;
	public $categoriesbymonth;


	public function __construct($name, $internalsafename, $safename, $titles, $dates, $categories, $types, $postidsequence, $years, $postidsbyear, $postidsbymonth, $categoriesbyear, $categoriesbymonth)
	{	global $array_alldisplayandsafecategories;


		$this->name=$name;
		$this->internalsafename=$internalsafename;
		$this->safename=$safename;
		$this->titles=$titles;
		$this->dates=$dates;
		$this->categories=$categories;
		$this->types=$types;
		$this->postidsequence=$postidsequence;
		$this->years=$years;
			//$this->month=$months;

			//$months=0, 


		$this->postidsbyear=$postidsbyear;

		$this->postidsbymonth=$postidsbymonth;
		
		$this->categoriesbyear=$categoriesbyear;
		$this->categoriesbymonth=$categoriesbymonth;

	}
}

?>